﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;


public class CameraScript : MonoBehaviour
{

    public Transform target;

    [SerializeField]
    private float distance;
    public float xRotation;
    public float yRotation;

    // The min and max values that the camera won't go past
    [SerializeField]
    private float verticalMin = 0;
    [SerializeField]
    private float verticalMax = 70;

    public PlayerScript myPlayerScript;

    void Update()
    {
        xRotation += Input.GetAxis("R_Horizontal" + myPlayerScript.playerNumber);
        yRotation += Input.GetAxis("R_Vertical" + myPlayerScript.playerNumber);

        yRotation = Mathf.Clamp(yRotation, verticalMin, verticalMax);

        Vector3 direction = new Vector3(0, 0, -distance);
        Quaternion rotation = Quaternion.Euler(yRotation, xRotation, 0);
        transform.position = target.position + rotation * direction;
        transform.LookAt(target.position);


    }
}
