﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class InterDog : Interactable
{
    private bool beingWalked;

    public bool leash;
    public LineRenderer lineRend;

    private bool playerHasLeash;
    private Transform leashLocation;

    public float maxDistance;
    private float distanceWalked;
    private Vector3 lastPos;
    private bool doneWalking;

    public GameObject door;
    public GameObject leashObj;

    protected override void Start()
    {
        base.Start();

        lastPos = transform.position;
    }

    public override void Interact(PlayerScript aPlayer)
    {
        if (doneWalking)
            return;

        if (leash)
        {
            aPlayer.hasLeash = true;
            ObjectManager.objectManager.UseItem(this, aPlayer.playerNumber);
            //transform.parent = GameObject.Find("DogLocation").transform;
            //transform.localPosition = Vector3.zero;
            gameObject.SetActive(false);
        }
        else
        {
            if (!timerStarted)
            {
                timerStarted = true;

                ObjectManager.objectManager.UseItem(this, aPlayer.playerNumber);

                playerInteracted = aPlayer;
                beingWalked = true;

                if (aPlayer.hasLeash)
                {
                    playerHasLeash = true;
                    lineRend.enabled = true;
                    leashLocation = GameObject.Find("DogLocation"+ aPlayer.playerNumber).transform;
                }
                else
                {
                    GetComponent<Rigidbody>().isKinematic = true;
                    GetComponent<BoxCollider>().enabled = false;
                    transform.parent = GameObject.Find("DogLocation"+ aPlayer.playerNumber).transform;
                    transform.localPosition = Vector3.zero;
                }

                door.SetActive(false);
                leashObj.SetActive(false);
                itemTypeImg.enabled = false;
                //StartCoroutine(TimedInteraction(completeTime));
            }
        }
        /*
        else if (timedDone)
        {
            aPlayer.CompleteItem(myToDoItem, points);
            gameObject.SetActive(false);
        }
        */
    }

    protected override void Update()
    {
        base.Update();

        if (beingWalked)
        {
            if (playerHasLeash)
            {
                lineRend.SetPosition(0, leashLocation.position);
                lineRend.SetPosition(1, transform.position);

                GetComponent<Rigidbody>().AddForce((playerInteracted.transform.position - transform.position).normalized * 10);
            }
        }
    }

    void FixedUpdate()
    {
        if(beingWalked && transform.position.z > 6)
        {
            float dist = (Vector3.Distance(lastPos, transform.position) * (playerHasLeash ? 2f : 1f));
            distanceWalked += dist;

            if(distanceWalked > maxDistance)
            {
                playerInteracted.CompleteItem(myToDoItem, points);
                lineRend.enabled = false;
                doneWalking = true;
                beingWalked = false;

                GetComponent<Rigidbody>().isKinematic = false;
                GetComponent<BoxCollider>().enabled = true;
                transform.parent = null;
            }

            lastPos = transform.position;
        }
    }
}