﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class InterPlayerLock : Interactable
{
    float lastQTE = 0;
    float nextQTE;
    bool haveQTE = false;
    int selectedButton;

    private float curPercentVal = 0;

    private int QTEMax;
    private int QTECur;

    protected override void Start()
    {
        base.Start();

        QTEMax = ((int)completeTime + 20) / 5;
        nextQTE = 1;// Random.Range(2f, 5f);
    }

    public override void Interact(PlayerScript aPlayer)
    {
        if (otherUsed)
            return;

        if (!timerStarted)
        {
            timerStarted = true;

            ObjectManager.objectManager.UseItem(this, aPlayer.playerNumber);

            playerInteracted = aPlayer;
            Debug.Log("Started " + myToDoItem + " for player " + aPlayer.playerNumber + "!");
            StartCoroutine(TimedInteraction(completeTime));
        }
    }

    protected override void Update()
    {
        base.Update();

        if(haveQTE)
        {
            if(Input.GetButtonDown("QTE" + selectedButton + playerInteracted.playerNumber))
            {
                playerInteracted.gameObject.GetComponent<MovementControl>().DoAnim(Random.Range(0, 3), true);
                QTECur++;
                //curPercentVal += nextQTE;
                //itemTypeImg.text = "";
                NextQTE();
            }
            else if (Input.GetButtonDown("QTE" + ((selectedButton+1)%4) + playerInteracted.playerNumber))
            {
                haveQTE = false;
                playerInteracted.gameObject.GetComponent<MovementControl>().DoAnim(Random.Range(0, 4), false);
                QTECur--;
                lastQTE = Time.time;
                nextQTE = 2;
                //curPercentVal -= nextQTE;
                itemTypeImg.text = "";
            }
            else if (Input.GetButtonDown("QTE" + ((selectedButton + 2) % 4) + playerInteracted.playerNumber))
            {
                haveQTE = false;
                playerInteracted.gameObject.GetComponent<MovementControl>().DoAnim(Random.Range(0, 4), false);
                QTECur--;
                lastQTE = Time.time;
                nextQTE = 2;
                //curPercentVal -= nextQTE;
                itemTypeImg.text = "";
            }
            else if (Input.GetButtonDown("QTE" + ((selectedButton + 3) % 4) + playerInteracted.playerNumber))
            {
                haveQTE = false;
                playerInteracted.gameObject.GetComponent<MovementControl>().DoAnim(Random.Range(0, 4), false);
                QTECur--;
                lastQTE = Time.time;
                nextQTE = 2;
                //curPercentVal -= nextQTE;
                itemTypeImg.text = "";
            }
        }
    }

    IEnumerator TimedInteraction(float aTime)
    {
        playerInteracted.gameObject.GetComponent<Rigidbody>().isKinematic = true;

        float startTime = Time.time;

        //itemTypeImg.gameObject.SetActive(false);
        timerParent.SetActive(true);
        lastQTE = Time.time;

        while (QTECur < QTEMax)
        {
            timerVisuals.GetComponent<RectTransform>().localPosition = new Vector3(0, Mathf.Lerp(-100, 0, ((float)QTECur) / ((float)QTEMax)), 0);

            if(!haveQTE && Time.time - lastQTE > nextQTE)
            {
                lastQTE = Time.time;
                //nextQTE = 5;//Random.Range(4f, 5f);
                haveQTE = true;
                selectedButton = Random.Range(0, 4);

                itemTypeImg.text = buttonStrings[selectedButton];
            }

            yield return new WaitForEndOfFrame();
        }

        Debug.Log("Done " + myToDoItem + " for player " + playerInteracted.playerNumber + "!");

        timedDone = true;

        playerInteracted.gameObject.GetComponent<Rigidbody>().isKinematic = false;
        playerInteracted.gameObject.GetComponent<MovementControl>().ResetAllTriggers();
        playerInteracted.CompleteItem(myToDoItem, points);
        itemTypeImg.text = completeString;
        itemTypeImg.gameObject.SetActive(true);
        timerParent.SetActive(false);
        haveQTE = false;
        //gameObject.SetActive(false);
    }

    private void NextQTE()
    {
        selectedButton = Random.Range(0, 4);

        itemTypeImg.text = buttonStrings[selectedButton];

        lastQTE = Time.time;
    }
}
