﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class ToDoList : MonoBehaviour
{
    public enum ToDoListItem
    {
        Hygiene,
        Dress,
        Breakfast,
        Dog,
        Lunch,
        Mom,
    }

    private Dictionary<ToDoListItem, ItemTrack> theToDoList = new Dictionary<ToDoListItem, ItemTrack>();

    public List<Text> uiText;
    public List<Image> uiImgs;

    public GameObject frontDoor;

    void Start()
    {
        for (int i = 0; i < 6; i++)
        {
            ItemTrack it = new ItemTrack();
            uiText[i].text = ((ToDoListItem)i).ToString();
            it.img = uiImgs[i];

            theToDoList.Add((ToDoListItem)i, it);
        }
    }

    public bool StartedItem(ToDoListItem aItemType)
    {
        Debug.Log(string.Format("{0} started {1}", transform.name, aItemType));
        if (!theToDoList[aItemType].startedItem)
        {
            theToDoList[aItemType].startedItem = true;
            return true;
        }
        else
        {
            return false;
        }
    }

    public void CompleteItem(ToDoListItem aItemType)
    {
        Debug.Log(string.Format("{0} completed {1}", transform.name, aItemType));
        theToDoList[aItemType].completedItem = true;
        theToDoList[aItemType].img.color = Color.green;

        if(theToDoList[ToDoListItem.Breakfast].completedItem 
            && theToDoList[ToDoListItem.Dog].completedItem
            && theToDoList[ToDoListItem.Hygiene].completedItem)
        {
            frontDoor.SetActive(false);
        }
    }
}

public class ItemTrack
{
    public bool startedItem;
    public bool completedItem;
    public Image img;
}