﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.SceneManagement;

public class WorkDoor : MonoBehaviour {

    private Scene currentScene;
    [SerializeField] private string currentSceneName;
    [SerializeField]private string tagContains = "Player";
    [SerializeField]private string sceneToLoad;

    //enum to change the state of the EndGame function to either Debug, or Load a scene
    enum DoorAction
    {
        DebugLog,
        LoadScene,
        CalculateScore// Need to add functinality here and make this the default value
    }

    [SerializeField]private DoorAction doorAction = DoorAction.DebugLog;

	void Start () 
	{
        currentScene = SceneManager.GetActiveScene();
	}
	
	void OnTriggerStay (Collider other) 
	{
        if (other.tag == tagContains)
        {
            if (Input.GetButtonDown("Use"+other.GetComponent<PlayerScript>().playerNumber))
            {
                other.GetComponent<PlayerScript>().GotToWork();
                //EndGame(doorAction, other);
            }
        }
	}

    void EndGame(DoorAction action, Collider other)// Put whatever logic we need in here to end the game
    {
        switch(action)
        {
            case DoorAction.DebugLog:
                Debug.Log(other.name + " has arrived to work!");
                break;
            case DoorAction.LoadScene:
                SceneManager.LoadScene(sceneToLoad);
                break;
            case DoorAction.CalculateScore:
                // Insert logic here
                break;
        }
    }
}
